#ifndef __TUM3D__DWT_FLOAT_FILTERS_CUH__
#define __TUM3D__DWT_FLOAT_FILTERS_CUH__


#define FILTER_LENGTH 9
#define FILTER_OFFSET 4
#define FILTER_OFFSET_RIGHT (FILTER_LENGTH - FILTER_OFFSET - 1)
#define COEFFICIENT_COUNT (2 * FILTER_LENGTH)

__device__ static const float g_ForwardFilterCoefficients[COEFFICIENT_COUNT] = {
	0.026749f,-0.016864f,-0.078223f, 0.266864f, 0.602949f, 0.266864f,-0.078223f,-0.016864f, 0.026749f,
	0.0f,      0.045636f,-0.028772f,-0.29564f,  0.55754f, -0.29564f, -0.028772f, 0.045636f, 0.0f
};
__device__ static const float g_InverseFilterCoefficients[COEFFICIENT_COUNT] = {
	0.0f,      0.033728f,-0.057544f,-0.533728f, 1.115087f,-0.533728f,-0.057544f, 0.033728f, 0.0f, 
	0.053498f,-0.091272f,-0.156446f, 0.591272f, 1.205898f, 0.591272f,-0.156446f,-0.091272f, 0.053498f
};

//#define FILTER_LENGTH 5
//#define FILTER_OFFSET 2
//#define FILTER_OFFSET_RIGHT (FILTER_LENGTH - FILTER_OFFSET - 1)
//#define COEFFICIENT_COUNT (2 * FILTER_LENGTH)
//
//__device__ static const float g_ForwardFilterCoefficients[COEFFICIENT_COUNT] = {
//	-0.125f, 0.25f, 0.75f, 0.25f,-0.125f,
//	 0.0f,  -0.25f, 0.5f, -0.25f, 0.0f
//};
//__device__ static const float g_InverseFilterCoefficients[COEFFICIENT_COUNT] = {
//	 0.0f,  -0.5f,  1.0f, -0.5f,  0.0f,
//	-0.25f,  0.5f,  1.5f,  0.5f, -0.25f
//};

//#define FILTER_LENGTH 4
//#define FILTER_OFFSET 2
//#define FILTER_OFFSET_RIGHT (FILTER_LENGTH - FILTER_OFFSET - 1)
//#define COEFFICIENT_COUNT (2 * FILTER_LENGTH)
//
//__device__ static const float g_ForwardFilterCoefficients[COEFFICIENT_COUNT] = {
//	0, 0.0f, 0.5f, 0.5f,
//	0,-0.5f, 0.5f, 0.0f
//};
//__device__ static const float g_InverseFilterCoefficients[COEFFICIENT_COUNT] = {
//	0, 0.0f, 1.0f,-1.0f,
//	0, 1.0f, 1.0f, 0.0f
//};

//#define FILTER_LENGTH 3
//#define FILTER_OFFSET 1
//#define FILTER_OFFSET_RIGHT (FILTER_LENGTH - FILTER_OFFSET - 1)
//#define COEFFICIENT_COUNT (2 * FILTER_LENGTH)
//
//__device__ static const float g_ForwardFilterCoefficients[COEFFICIENT_COUNT] = {
//	 0.0f, 0.5f, 0.5f,
//	-0.5f, 0.5f, 0.0f
//};
//__device__ static const float g_InverseFilterCoefficients[COEFFICIENT_COUNT] = {
//	 0.0f, 1.0f,-1.0f,
//	 1.0f, 1.0f, 0.0f
//};


#endif
