#ifndef __TUM3D_CUDACOMPRESS__HUFFMAN_CPU_H__
#define __TUM3D_CUDACOMPRESS__HUFFMAN_CPU_H__


#include "global.h"

#include <vector>

#include "tools/BitStream.h"

#include "HuffmanTableCPU.h"


namespace cudaCompress {

bool huffmanEncodeCPU(BitStream& bitStream, const std::vector<Symbol>& symbolStream, const HuffmanEncodeTableCPU& encodeTable, std::vector<uint>& offsets, uint offsetInterval);
bool huffmanDecodeCPU(BitStreamReadOnly& bitStream, uint symbolCount, std::vector<Symbol>& symbolStream, const HuffmanDecodeTableCPU& decodeTable);

}


#endif
