#include "reduce.h"

#include "../tools/Operator.h"
#include "../tools/Functor.h"

#include "reduce_app.cui"


void reduceMinShort(short* dpResult, const short* dpData, size_t elemCount, ReducePlan* pPlan)
{
	reduceArray<short, OperatorMin<short>>(dpResult, dpData, elemCount, pPlan);
}

void reduceMaxShort(short* dpResult, const short* dpData, size_t elemCount, ReducePlan* pPlan)
{
	reduceArray<short, OperatorMax<short>>(dpResult, dpData, elemCount, pPlan);
}

void reduceMaxAbsFloat(float* dpResult, const float* dpData, size_t elemCount, ReducePlan* pPlan)
{
	reduceArray<float, OperatorMax<float>, FunctorAbs<float>>(dpResult, dpData, elemCount, pPlan);
}
