#ifndef __SCAN_PLAN_H__
#define __SCAN_PLAN_H__


#include "../global.h"


class ScanPlan
{
public:
    ScanPlan(size_t elemSizeBytes, size_t numElements);
    ~ScanPlan();

    size_t  m_numElements;        // Maximum number of input elements
	size_t  m_elemSizeBytes;      // Size of each element in bytes, i.e. sizeof(T)
    void**  m_blockSums;          // Intermediate block sums array
    size_t  m_numLevelsAllocated; // Number of levels allocated (in m_blockSums)
};


#endif
