#ifndef __TUM3D_CUDACOMPRESS__BITS_H__
#define __TUM3D_CUDACOMPRESS__BITS_H__


#include "global.h"


namespace cudaCompress {

//WARNING: for now, elemCount has to be a multiple of 4096 (or the arrays padded accordingly)
//TODO: fix this!

// store least significant bit from each element in dpData in dpBits
bool getLSB(const short* dpData, uint* dpBits, uint elemCount);

// remove least significant bit from each element in dpData (ie round down) and store in dpBits (if non-null)
// shift is added to each value before the bit is removed
bool removeLSB(short* dpData, uint* dpBits, uint elemCount, short shift = 0);

// append corresponding bit from dpBits onto each element in dpData (as least significant bit)
// shift is added to each value after the bit has been appended
bool appendLSB(short* dpData, const uint* dpBits, uint elemCount, short shift = 0);

// add shift to each element of dpData
bool shiftElems(short* dpData, uint elemCount, short shift);

}


#endif
