#ifndef __TUM3D_CUDACOMPRESS__RICE_GOLOMB_CPU_H__
#define __TUM3D_CUDACOMPRESS__RICE_GOLOMB_CPU_H__


#include "global.h"

#include <vector>

#include "tools/BitStream.h"

#include "EncodeCommon.h"


namespace cudaCompress {

bool riceGolombEncodeCPU(BitStream& bitStream, const std::vector<Symbol>& symbolStream, uint kBlockSize, std::vector<uint>& offsets, uint offsetIntervalInBlocks);
bool riceGolombDecodeCPU(BitStreamReadOnly& bitStream, uint symbolCount, std::vector<Symbol>& symbolStream, uint kBlockSize);

}


#endif
