#ifndef __TUM3D_CUDACOMPRESS__RUN_LENGTH_H__
#define __TUM3D_CUDACOMPRESS__RUN_LENGTH_H__


#include "global.h"

#include <vector>

#include "EncodeCommon.h"


namespace cudaCompress {

class Instance;


size_t runLengthGetRequiredMemory(const Instance* pInstance);
bool runLengthInit(Instance* pInstance);
bool runLengthShutdown(Instance* pInstance);

bool runLengthEncode(Instance* pInstance, Symbol** pdpSymbolsCompact, ushort** pdpZeroCounts, const Symbol** pdpSymbols, const uint* pSymbolCount, uint streamCount, uint zeroCountMax, uint* pSymbolCountCompact);
bool runLengthDecode(Instance* pInstance, const Symbol** pdpSymbolsCompact, const ushort** pdpZeroCounts, const uint* pSymbolCountCompact, Symbol** pdpSymbols, const uint* pSymbolCount, uint streamCount);

}


#endif
