#ifndef __TUM3D_CUDACOMPRESS__RUN_LENGTH_CPU_H__
#define __TUM3D_CUDACOMPRESS__RUN_LENGTH_CPU_H__


#include "global.h"

#include <vector>

#include "EncodeCommon.h"


namespace cudaCompress {

bool runLengthZeroesEncodeCPU(std::vector<Symbol>& symbolsCompact, std::vector<ushort>& zeroCounts, const std::vector<Symbol>& symbols, uint zeroCountMax);
bool runLengthZeroesDecodeCPU(const std::vector<Symbol>& symbolsCompact, const std::vector<ushort>& zeroCounts, std::vector<Symbol>& symbols, uint symbolCount);

bool runLengthEncodeCPU(std::vector<Symbol>& runSymbols, std::vector<ushort>& runLengths, const std::vector<Symbol>& symbols, uint runLengthMax);
bool runLengthDecodeCPU(const std::vector<Symbol>& runSymbols, const std::vector<ushort>& runLengths, std::vector<Symbol>& symbols, uint symbolCount);

}


#endif
