#include "Timing.h"

#include "cudaUtil.h"
#include "util.h"

#include "Instance.h"


namespace cudaCompress {

void setTimingDetail(void* pCudaCompressInstance, ETimingDetail detail)
{
	Instance* pInstance = (Instance*)pCudaCompressInstance;
	pInstance->setTimingDetail(detail);
}

void printTimings(void* pCudaCompressInstance)
{
	Instance* pInstance = (Instance*)pCudaCompressInstance;
	pInstance->printTimings();
}

void resetTimings(void* pCudaCompressInstance)
{
	Instance* pInstance = (Instance*)pCudaCompressInstance;
	pInstance->resetTimings();
}

}
