#ifndef __TUM3D_CUDACOMPRESS__TIMING_H__
#define __TUM3D_CUDACOMPRESS__TIMING_H__


#include "global.h"

#include <string>
#include <vector>


namespace cudaCompress {

enum ETimingDetail
{
	TIMING_DETAIL_NONE,
	TIMING_DETAIL_LOW,
	TIMING_DETAIL_MEDIUM,
	TIMING_DETAIL_HIGH,
};

void CUCOMP_DLL setTimingDetail(void* pCudaCompressInstance, ETimingDetail detail);

//TODO getTimings()
void CUCOMP_DLL printTimings(void* pCudaCompressInstance);
void CUCOMP_DLL resetTimings(void* pCudaCompressInstance);

}


#endif
