#ifndef __TUM3D_CUDACOMPRESS__YCOCG_H__
#define __TUM3D_CUDACOMPRESS__YCOCG_H__


#include "global.h"


namespace cudaCompress {

// RGB <-> YCoCg color space conversion
// dpTarget and dpData may point to the same memory
CUCOMP_DLL void convertRGBtoYCoCg(byte* dpTarget, const byte* dpData, int pixelCount);
CUCOMP_DLL void convertYCoCgtoRGB(byte* dpTarget, const byte* dpData, int pixelCount);

}


#endif
